

<!DOCTYPE html>
<html class="writer-html5" lang="en" data-content_root="../../../">
<head>
  <meta charset="utf-8" />
  <meta name="viewport" content="width=device-width, initial-scale=1.0" />
  <title>gwmat.bilby_custom_FD_source_models.microlensing_source &mdash; GWMAT: Gravitational Wave Microlensing Analysis Tools 1.0.0 documentation</title>
      <link rel="stylesheet" type="text/css" href="../../../_static/pygments.css?v=80d5e7a1" />
      <link rel="stylesheet" type="text/css" href="../../../_static/css/theme.css?v=7ab3649f" />

  
      <script src="../../../_static/jquery.js?v=5d32c60e"></script>
      <script src="../../../_static/_sphinx_javascript_frameworks_compat.js?v=2cd50e6c"></script>
      <script src="../../../_static/documentation_options.js?v=8d563738"></script>
      <script src="../../../_static/doctools.js?v=9a2dae69"></script>
      <script src="../../../_static/sphinx_highlight.js?v=dc90522c"></script>
    <script src="../../../_static/js/theme.js"></script>
    <link rel="index" title="Index" href="../../../genindex.html" />
    <link rel="search" title="Search" href="../../../search.html" /> 
</head>

<body class="wy-body-for-nav"> 
  <div class="wy-grid-for-nav">
    <nav data-toggle="wy-nav-shift" class="wy-nav-side">
      <div class="wy-side-scroll">
        <div class="wy-side-nav-search" >

          
          
          <a href="../../../index.html" class="icon icon-home">
            GWMAT: Gravitational Wave Microlensing Analysis Tools
          </a>
<div role="search">
  <form id="rtd-search-form" class="wy-form" action="../../../search.html" method="get">
    <input type="text" name="q" placeholder="Search docs" aria-label="Search docs" />
    <input type="hidden" name="check_keywords" value="yes" />
    <input type="hidden" name="area" value="default" />
  </form>
</div>
        </div><div class="wy-menu wy-menu-vertical" data-spy="affix" role="navigation" aria-label="Navigation menu">
              <ul>
<li class="toctree-l1"><a class="reference internal" href="../../../gwmat.html">gwmat package</a></li>
</ul>

        </div>
      </div>
    </nav>

    <section data-toggle="wy-nav-shift" class="wy-nav-content-wrap"><nav class="wy-nav-top" aria-label="Mobile navigation menu" >
          <i data-toggle="wy-nav-top" class="fa fa-bars"></i>
          <a href="../../../index.html">GWMAT: Gravitational Wave Microlensing Analysis Tools</a>
      </nav>

      <div class="wy-nav-content">
        <div class="rst-content">
          <div role="navigation" aria-label="Page navigation">
  <ul class="wy-breadcrumbs">
      <li><a href="../../../index.html" class="icon icon-home" aria-label="Home"></a></li>
          <li class="breadcrumb-item"><a href="../../index.html">Module code</a></li>
          <li class="breadcrumb-item"><a href="../../gwmat.html">gwmat</a></li>
      <li class="breadcrumb-item active">gwmat.bilby_custom_FD_source_models.microlensing_source</li>
      <li class="wy-breadcrumbs-aside">
      </li>
  </ul>
  <hr/>
</div>
          <div role="main" class="document" itemscope="itemscope" itemtype="http://schema.org/Article">
           <div itemprop="articleBody">
             
  <h1>Source code for gwmat.bilby_custom_FD_source_models.microlensing_source</h1><div class="highlight"><pre>
<span></span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">Author: Anuj Mishra</span>

<span class="sd">This module contains a Bilby source file designed for </span>
<span class="sd">performing parameter estimation under the assumption </span>
<span class="sd">of an isolated point lens model.</span>

<span class="sd">**Methodology for Efficient Lensing Amplification Factor Computation** :</span>

<span class="sd">1. **Precompute the Wave Optics Part**: A lookup table is generated to </span>
<span class="sd">precompute the &quot;wave optics&quot; contribution.</span>

<span class="sd">2. **Geometrical Optics with Cython**: Cython is employed to compute </span>
<span class="sd">the &quot;geometrical optics&quot; part efficiently using the power of C.</span>

<span class="sd">3. **Dynamic Frequency Cutoff**: A frequency cutoff, dependent on the </span>
<span class="sd">impact parameter, shifts the computation from wave to geometrical optics. </span>
<span class="sd">This cutoff is based on a numerical fit to ensure that the relative error </span>
<span class="sd">between the analytic \( F(f) \) and the geometrical optics approximation </span>
<span class="sd">is less than 1% for frequencies above the cutoff.</span>

<span class="sd">**Lookup Table** :</span>
<span class="sd">The lookup table must be generated before using the source function. A script to generate the table is available at `&#39;gwmat/scripts/generate_point_lens_Ff_lookup_table.py&#39;`. Once generated, the table can be provided to the sampler via the `&quot;lookup_table_path&quot;` keyword argument in **kwargs.</span>

<span class="sd">**Handling Lens Mass** :</span>
<span class="sd">The `point_lens_Ff_lookup_table` function, which uses the lookup table, can handle any lens mass, provided it falls within the impact parameter range used when building the table. Typically, a lens mass range of \( (10^{-1}, 10^5) \) is sufficient for most use cases.</span>

<span class="sd">**Non-Lookup Table Version** :</span>
<span class="sd">This module also includes a source model that does not rely on the lookup table, though it is slower due to the absence of precomputed values.</span>
<span class="sd">&quot;&quot;&quot;</span>


<span class="kn">from</span> <span class="nn">bilby.gw.source</span> <span class="kn">import</span> <span class="n">lal_binary_black_hole</span>
<span class="kn">import</span> <span class="nn">numpy</span> <span class="k">as</span> <span class="nn">np</span>
<span class="kn">from</span> <span class="nn">scipy.interpolate</span> <span class="kn">import</span> <span class="n">interp1d</span>

<span class="kn">import</span> <span class="nn">gwmat</span>


<span class="c1">## functions</span>
<div class="viewcode-block" id="y_w_grid_data">
<a class="viewcode-back" href="../../../gwmat.bilby_custom_FD_source_models.html#gwmat.bilby_custom_FD_source_models.microlensing_source.y_w_grid_data">[docs]</a>
<span class="k">def</span> <span class="nf">y_w_grid_data</span><span class="p">(</span><span class="n">Ff_grid</span><span class="p">):</span>
    <span class="n">ys_grid</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">Ff_grid</span><span class="p">[</span><span class="nb">str</span><span class="p">(</span><span class="n">i</span><span class="p">)][</span><span class="s2">&quot;y&quot;</span><span class="p">]</span> <span class="k">for</span> <span class="n">i</span> <span class="ow">in</span> <span class="nb">range</span><span class="p">(</span><span class="nb">len</span><span class="p">(</span><span class="n">Ff_grid</span><span class="p">))])</span>
    <span class="n">ws_grid</span> <span class="o">=</span> <span class="n">Ff_grid</span><span class="p">[</span><span class="nb">str</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">argmin</span><span class="p">(</span><span class="n">ys_grid</span><span class="p">))][</span><span class="s2">&quot;ws&quot;</span><span class="p">]</span>
    <span class="k">return</span> <span class="n">ys_grid</span><span class="p">,</span> <span class="n">ws_grid</span></div>



<div class="viewcode-block" id="y_index">
<a class="viewcode-back" href="../../../gwmat.bilby_custom_FD_source_models.html#gwmat.bilby_custom_FD_source_models.microlensing_source.y_index">[docs]</a>
<span class="k">def</span> <span class="nf">y_index</span><span class="p">(</span><span class="n">yl</span><span class="p">,</span> <span class="n">ys_grid</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">argmin</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">ys_grid</span> <span class="o">-</span> <span class="n">yl</span><span class="p">))</span></div>



<div class="viewcode-block" id="w_index">
<a class="viewcode-back" href="../../../gwmat.bilby_custom_FD_source_models.html#gwmat.bilby_custom_FD_source_models.microlensing_source.w_index">[docs]</a>
<span class="k">def</span> <span class="nf">w_index</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">ws_grid</span><span class="p">):</span>
    <span class="k">return</span> <span class="n">np</span><span class="o">.</span><span class="n">argmin</span><span class="p">(</span><span class="n">np</span><span class="o">.</span><span class="n">abs</span><span class="p">(</span><span class="n">ws_grid</span> <span class="o">-</span> <span class="n">w</span><span class="p">))</span></div>



<div class="viewcode-block" id="point_lens_Ff_lookup_table">
<a class="viewcode-back" href="../../../gwmat.bilby_custom_FD_source_models.html#gwmat.bilby_custom_FD_source_models.microlensing_source.point_lens_Ff_lookup_table">[docs]</a>
<span class="k">def</span> <span class="nf">point_lens_Ff_lookup_table</span><span class="p">(</span>
    <span class="n">fs</span><span class="p">,</span> <span class="n">Mlz</span><span class="p">,</span> <span class="n">yl</span><span class="p">,</span> <span class="n">Ff_grid</span><span class="p">,</span> <span class="n">ys_grid</span><span class="p">,</span> <span class="n">ws_grid</span><span class="p">,</span> <span class="n">extrapolate</span><span class="o">=</span><span class="kc">False</span>
<span class="p">):</span>
    <span class="n">wfs</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">gwmat</span><span class="o">.</span><span class="n">cythonized_point_lens</span><span class="o">.</span><span class="n">w_of_f</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">Mlz</span><span class="p">)</span> <span class="k">for</span> <span class="n">f</span> <span class="ow">in</span> <span class="n">fs</span><span class="p">])</span>

    <span class="k">if</span> <span class="n">yl</span> <span class="o">&gt;=</span> <span class="mf">1e-2</span><span class="p">:</span>
        <span class="n">wc</span> <span class="o">=</span> <span class="n">gwmat</span><span class="o">.</span><span class="n">cythonized_point_lens</span><span class="o">.</span><span class="n">w_cutoff_geometric_optics_tolerance_1p0</span><span class="p">(</span><span class="n">yl</span><span class="p">)</span>
    <span class="k">else</span><span class="p">:</span>
        <span class="n">wc</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">wfs</span><span class="p">)</span>

    <span class="n">wfs_1</span> <span class="o">=</span> <span class="n">wfs</span><span class="p">[</span><span class="n">wfs</span> <span class="o">&lt;=</span> <span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">(</span><span class="n">ws_grid</span><span class="p">)]</span>
    <span class="n">Ffs_1</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">([</span><span class="n">gwmat</span><span class="o">.</span><span class="n">cythonized_point_lens</span><span class="o">.</span><span class="n">Fw_analytic</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">y</span><span class="o">=</span><span class="n">yl</span><span class="p">)</span> <span class="k">for</span> <span class="n">w</span> <span class="ow">in</span> <span class="n">wfs_1</span><span class="p">])</span>

    <span class="n">wfs_2</span> <span class="o">=</span> <span class="n">wfs</span><span class="p">[(</span><span class="n">wfs</span> <span class="o">&gt;</span> <span class="n">np</span><span class="o">.</span><span class="n">min</span><span class="p">(</span><span class="n">ws_grid</span><span class="p">))</span> <span class="o">&amp;</span> <span class="p">(</span><span class="n">wfs</span> <span class="o">&lt;=</span> <span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">ws_grid</span><span class="p">))]</span>
    <span class="n">wfs_2_wave</span> <span class="o">=</span> <span class="n">wfs_2</span><span class="p">[</span><span class="n">wfs_2</span> <span class="o">&lt;=</span> <span class="n">wc</span><span class="p">]</span>
    <span class="n">wfs_2_geo</span> <span class="o">=</span> <span class="n">wfs_2</span><span class="p">[</span><span class="n">wfs_2</span> <span class="o">&gt;</span> <span class="n">wc</span><span class="p">]</span>

    <span class="n">i_y</span> <span class="o">=</span> <span class="n">y_index</span><span class="p">(</span><span class="n">yl</span><span class="p">,</span> <span class="n">ys_grid</span><span class="p">)</span>
    <span class="n">tmp_Ff_dict</span> <span class="o">=</span> <span class="n">Ff_grid</span><span class="p">[</span><span class="nb">str</span><span class="p">(</span><span class="n">i_y</span><span class="p">)]</span>
    <span class="n">ws</span> <span class="o">=</span> <span class="n">tmp_Ff_dict</span><span class="p">[</span><span class="s2">&quot;ws&quot;</span><span class="p">]</span>
    <span class="n">Ffs</span> <span class="o">=</span> <span class="n">tmp_Ff_dict</span><span class="p">[</span><span class="s2">&quot;Ffs_real&quot;</span><span class="p">]</span> <span class="o">+</span> <span class="mi">1</span><span class="n">j</span> <span class="o">*</span> <span class="n">tmp_Ff_dict</span><span class="p">[</span><span class="s2">&quot;Ffs_imag&quot;</span><span class="p">]</span>
    <span class="n">fill_val</span> <span class="o">=</span> <span class="p">[</span><span class="s2">&quot;interpolate&quot;</span><span class="p">,</span> <span class="s2">&quot;extrapolate&quot;</span><span class="p">][</span><span class="n">extrapolate</span><span class="p">]</span>
    <span class="n">i_Ff</span> <span class="o">=</span> <span class="n">interp1d</span><span class="p">(</span><span class="n">ws</span><span class="p">,</span> <span class="n">Ffs</span><span class="p">,</span> <span class="n">fill_value</span><span class="o">=</span><span class="n">fill_val</span><span class="p">)</span>
    <span class="n">Ffs_2_wave</span> <span class="o">=</span> <span class="n">i_Ff</span><span class="p">(</span><span class="n">wfs_2_wave</span><span class="p">)</span>

    <span class="n">Ffs_2_geo</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span>
        <span class="p">[</span><span class="n">gwmat</span><span class="o">.</span><span class="n">cythonized_point_lens</span><span class="o">.</span><span class="n">Fw_geometric_optics</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">yl</span><span class="p">)</span> <span class="k">for</span> <span class="n">w</span> <span class="ow">in</span> <span class="n">wfs_2_geo</span><span class="p">]</span>
    <span class="p">)</span>

    <span class="n">wfs_3</span> <span class="o">=</span> <span class="n">wfs</span><span class="p">[</span><span class="n">wfs</span> <span class="o">&gt;</span> <span class="n">np</span><span class="o">.</span><span class="n">max</span><span class="p">(</span><span class="n">ws_grid</span><span class="p">)]</span>
    <span class="n">Ffs_3</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span>
        <span class="p">[</span><span class="n">gwmat</span><span class="o">.</span><span class="n">cythonized_point_lens</span><span class="o">.</span><span class="n">Fw_geometric_optics</span><span class="p">(</span><span class="n">w</span><span class="p">,</span> <span class="n">yl</span><span class="p">)</span> <span class="k">for</span> <span class="n">w</span> <span class="ow">in</span> <span class="n">wfs_3</span><span class="p">]</span>
    <span class="p">)</span>

    <span class="n">Ffs</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">concatenate</span><span class="p">((</span><span class="n">Ffs_1</span><span class="p">,</span> <span class="n">Ffs_2_wave</span><span class="p">,</span> <span class="n">Ffs_2_geo</span><span class="p">,</span> <span class="n">Ffs_3</span><span class="p">))</span>
    <span class="k">assert</span> <span class="nb">len</span><span class="p">(</span><span class="n">Ffs</span><span class="p">)</span> <span class="o">==</span> <span class="nb">len</span><span class="p">(</span><span class="n">fs</span><span class="p">),</span> <span class="s2">&quot;len(Ffs) = </span><span class="si">{}</span><span class="s2"> does not match len(fs) = </span><span class="si">{}</span><span class="s2">&quot;</span><span class="o">.</span><span class="n">format</span><span class="p">(</span>
        <span class="nb">len</span><span class="p">(</span><span class="n">Ffs</span><span class="p">),</span> <span class="nb">len</span><span class="p">(</span><span class="n">fs</span><span class="p">)</span>
    <span class="p">)</span>
    <span class="k">return</span> <span class="n">Ffs</span></div>



<span class="c1"># Define a global variable to hold the lookup table</span>
<span class="n">LOOKUP_TABLE</span> <span class="o">=</span> <span class="kc">None</span>


<div class="viewcode-block" id="load_lookup_table">
<a class="viewcode-back" href="../../../gwmat.bilby_custom_FD_source_models.html#gwmat.bilby_custom_FD_source_models.microlensing_source.load_lookup_table">[docs]</a>
<span class="k">def</span> <span class="nf">load_lookup_table</span><span class="p">(</span><span class="n">lookup_table_path</span><span class="p">):</span>
    <span class="k">global</span> <span class="n">LOOKUP_TABLE</span>
    <span class="k">if</span> <span class="n">LOOKUP_TABLE</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;## Loading and setting up the lookup table ##&quot;</span><span class="p">)</span>
        <span class="kn">import</span> <span class="nn">pickle</span>

        <span class="k">with</span> <span class="nb">open</span><span class="p">(</span><span class="n">lookup_table_path</span><span class="p">,</span> <span class="s2">&quot;rb&quot;</span><span class="p">)</span> <span class="k">as</span> <span class="n">f</span><span class="p">:</span>
            <span class="n">Ff_grid</span> <span class="o">=</span> <span class="n">pickle</span><span class="o">.</span><span class="n">load</span><span class="p">(</span><span class="n">f</span><span class="p">)</span>
        <span class="n">ys_grid</span><span class="p">,</span> <span class="n">ws_grid</span> <span class="o">=</span> <span class="n">y_w_grid_data</span><span class="p">(</span><span class="n">Ff_grid</span><span class="p">)</span>
        <span class="nb">print</span><span class="p">(</span><span class="s2">&quot;## Done ##&quot;</span><span class="p">)</span>
        <span class="n">LOOKUP_TABLE</span> <span class="o">=</span> <span class="p">(</span><span class="n">Ff_grid</span><span class="p">,</span> <span class="n">ys_grid</span><span class="p">,</span> <span class="n">ws_grid</span><span class="p">)</span>
    <span class="k">return</span> <span class="n">LOOKUP_TABLE</span></div>



<span class="c1">### S1. Source Model for point lens microlensing using lookup table ###</span>
<div class="viewcode-block" id="point_lens_microlensing_binary_black_hole">
<a class="viewcode-back" href="../../../gwmat.bilby_custom_FD_source_models.html#gwmat.bilby_custom_FD_source_models.microlensing_source.point_lens_microlensing_binary_black_hole">[docs]</a>
<span class="k">def</span> <span class="nf">point_lens_microlensing_binary_black_hole</span><span class="p">(</span>
    <span class="n">frequency_array</span><span class="p">,</span>
    <span class="n">mass_1</span><span class="p">,</span>
    <span class="n">mass_2</span><span class="p">,</span>
    <span class="n">luminosity_distance</span><span class="p">,</span>
    <span class="n">a_1</span><span class="p">,</span>
    <span class="n">tilt_1</span><span class="p">,</span>
    <span class="n">phi_12</span><span class="p">,</span>
    <span class="n">a_2</span><span class="p">,</span>
    <span class="n">tilt_2</span><span class="p">,</span>
    <span class="n">phi_jl</span><span class="p">,</span>
    <span class="n">theta_jn</span><span class="p">,</span>
    <span class="n">phase</span><span class="p">,</span>
    <span class="n">Log_Mlz</span><span class="p">,</span>
    <span class="n">yl</span><span class="p">,</span>
    <span class="o">**</span><span class="n">kwargs</span>
<span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This is a Bilby Frequency Domain Source model for </span>
<span class="sd">    performing parameter estimations assuming </span>
<span class="sd">    isolated point lens model.</span>

<span class="sd">    It returns microlensed frequency-domain plus and cross </span>
<span class="sd">    polarized waveforms evaluated at the required </span>
<span class="sd">    frequency_array.</span>

<span class="sd">    Parameters</span>
<span class="sd">    ----------</span>
<span class="sd">    * frequency_array : float</span>
<span class="sd">        Array of frequency values where the WF will be evaluated.</span>
<span class="sd">    * mass_1 : float</span>
<span class="sd">        The mass of the primary component object</span>
<span class="sd">        in the binary (in solar masses).</span>
<span class="sd">    * mass_2 : float</span>
<span class="sd">        The mass of the secondary component object in</span>
<span class="sd">        the binary (in solar masses).</span>
<span class="sd">    * a_1 : float, optional</span>
<span class="sd">        The dimensionless spin magnitude of object 1.</span>
<span class="sd">    * a_2 : float, optional</span>
<span class="sd">        The dimensionless spin magnitude of object 2.</span>
<span class="sd">    * tilt_1 : ({0.,float}), optional</span>
<span class="sd">        Angle between L and the spin magnitude of object 1.</span>
<span class="sd">    * tilt_2 : float, optional</span>
<span class="sd">        Angle between L and the spin magnitude of object 2.</span>
<span class="sd">    * phi_12 : float, optional</span>
<span class="sd">        Difference between the azimuthal angles of</span>
<span class="sd">        the spin of the object 1 and 2.</span>
<span class="sd">    * phi_jl : float, optional</span>
<span class="sd">        Azimuthal angle of L on its cone about J.</span>
<span class="sd">    * Log_Mlz : float</span>
<span class="sd">        Redshifted Mass of the point-lens in</span>
<span class="sd">        log10 scale (in solar masses).</span>
<span class="sd">    * yl : float</span>
<span class="sd">        The dimensionless impact parameter between</span>
<span class="sd">        the lens and the source.</span>
<span class="sd">    * theta_jn : float, optional</span>
<span class="sd">        Angle between the line of sight and</span>
<span class="sd">        the total angular momentum J.</span>
<span class="sd">    * luminosity_distance : ({100.,float}), optional</span>
<span class="sd">        Luminosity distance to the binary (in Mpc).</span>
<span class="sd">    * theta_jn : float</span>
<span class="sd">        Inclination (rad), defined as the angle between</span>
<span class="sd">        the orbital angular momentum J(or, L) and the</span>
<span class="sd">        line-of-sight at the reference frequency.</span>
<span class="sd">        Default = 0.</span>
<span class="sd">    * phase : ({0.,float}), optional</span>
<span class="sd">        Coalesence phase of the binary (in rad).</span>

<span class="sd">    Returns</span>
<span class="sd">    -------</span>
<span class="sd">    Dictionary:</span>
<span class="sd">        * plus: A numpy array.</span>
<span class="sd">            Strain values of the plus polarized WF in Frequency Domain..</span>
<span class="sd">        * cross: A numpy array.</span>
<span class="sd">            Strain values of the cross polarized WF in Frequency Domain.</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">waveform_kwargs</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span>
        <span class="n">waveform_approximant</span><span class="o">=</span><span class="s2">&quot;IMRPhenomPv2&quot;</span><span class="p">,</span>
        <span class="n">reference_frequency</span><span class="o">=</span><span class="mf">50.0</span><span class="p">,</span>
        <span class="n">minimum_frequency</span><span class="o">=</span><span class="mf">20.0</span><span class="p">,</span>
        <span class="n">maximum_frequency</span><span class="o">=</span><span class="n">frequency_array</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span>
        <span class="n">catch_waveform_errors</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
        <span class="n">pn_spin_order</span><span class="o">=-</span><span class="mi">1</span><span class="p">,</span>
        <span class="n">pn_tidal_order</span><span class="o">=-</span><span class="mi">1</span><span class="p">,</span>
        <span class="n">pn_phase_order</span><span class="o">=-</span><span class="mi">1</span><span class="p">,</span>
        <span class="n">pn_amplitude_order</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span>
        <span class="n">lookup_table_path</span><span class="o">=</span><span class="s2">&quot;/home/anuj.mishra/git_repos/gwmat/data/lookup_table_data/</span><span class="se">\</span>
<span class="s2">        point_lens_Ff_lookup_table_Geo_relErr_1p0_Mlz_1e-1_1e5_ys_1e-3_5.pkl&quot;</span><span class="p">,</span>
    <span class="p">)</span>
    <span class="n">waveform_kwargs</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">kwargs</span><span class="p">)</span>

    <span class="k">global</span> <span class="n">LOOKUP_TABLE</span>
    <span class="k">if</span> <span class="n">LOOKUP_TABLE</span> <span class="ow">is</span> <span class="kc">None</span><span class="p">:</span>
        <span class="n">LOOKUP_TABLE</span> <span class="o">=</span> <span class="n">load_lookup_table</span><span class="p">(</span>
            <span class="n">lookup_table_path</span><span class="o">=</span><span class="n">waveform_kwargs</span><span class="p">[</span><span class="s2">&quot;lookup_table_path&quot;</span><span class="p">]</span>
        <span class="p">)</span>
    <span class="n">Ff_grid</span><span class="p">,</span> <span class="n">ys_grid</span><span class="p">,</span> <span class="n">ws_grid</span> <span class="o">=</span> <span class="n">LOOKUP_TABLE</span>

    <span class="n">lal_res</span> <span class="o">=</span> <span class="n">lal_binary_black_hole</span><span class="p">(</span>
        <span class="n">frequency_array</span><span class="p">,</span>
        <span class="n">mass_1</span><span class="p">,</span>
        <span class="n">mass_2</span><span class="p">,</span>
        <span class="n">luminosity_distance</span><span class="p">,</span>
        <span class="n">a_1</span><span class="p">,</span>
        <span class="n">tilt_1</span><span class="p">,</span>
        <span class="n">phi_12</span><span class="p">,</span>
        <span class="n">a_2</span><span class="p">,</span>
        <span class="n">tilt_2</span><span class="p">,</span>
        <span class="n">phi_jl</span><span class="p">,</span>
        <span class="n">theta_jn</span><span class="p">,</span>
        <span class="n">phase</span><span class="p">,</span>
        <span class="o">**</span><span class="n">kwargs</span>
    <span class="p">)</span>
    
    <span class="k">if</span> <span class="n">Log_Mlz</span> <span class="o">&lt;</span> <span class="o">-</span><span class="mi">3</span><span class="p">:</span>
        <span class="k">return</span> <span class="nb">dict</span><span class="p">(</span><span class="n">plus</span><span class="o">=</span><span class="n">lal_res</span><span class="p">[</span><span class="s2">&quot;plus&quot;</span><span class="p">],</span> <span class="n">cross</span><span class="o">=</span><span class="n">lal_res</span><span class="p">[</span><span class="s2">&quot;cross&quot;</span><span class="p">])</span>

    <span class="n">Mlz</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">power</span><span class="p">(</span><span class="mf">10.</span><span class="p">,</span> <span class="n">Log_Mlz</span><span class="p">)</span>
    <span class="n">Ff</span> <span class="o">=</span> <span class="n">point_lens_Ff_lookup_table</span><span class="p">(</span>
        <span class="n">fs</span><span class="o">=</span><span class="n">frequency_array</span><span class="p">,</span>
        <span class="n">Mlz</span><span class="o">=</span><span class="n">Mlz</span><span class="p">,</span>
        <span class="n">yl</span><span class="o">=</span><span class="n">yl</span><span class="p">,</span>
        <span class="n">Ff_grid</span><span class="o">=</span><span class="n">Ff_grid</span><span class="p">,</span>
        <span class="n">ys_grid</span><span class="o">=</span><span class="n">ys_grid</span><span class="p">,</span>
        <span class="n">ws_grid</span><span class="o">=</span><span class="n">ws_grid</span><span class="p">,</span>
    <span class="p">)</span>
    <span class="n">lhp</span> <span class="o">=</span> <span class="n">Ff</span> <span class="o">*</span> <span class="n">lal_res</span><span class="p">[</span><span class="s2">&quot;plus&quot;</span><span class="p">]</span>
    <span class="n">lhc</span> <span class="o">=</span> <span class="n">Ff</span> <span class="o">*</span> <span class="n">lal_res</span><span class="p">[</span><span class="s2">&quot;cross&quot;</span><span class="p">]</span>
    <span class="k">return</span> <span class="nb">dict</span><span class="p">(</span><span class="n">plus</span><span class="o">=</span><span class="n">lhp</span><span class="p">,</span> <span class="n">cross</span><span class="o">=</span><span class="n">lhc</span><span class="p">)</span></div>



<span class="c1">### S2. Source Model for point lens microlensing using Analytic func + Geo Optics approx. (more accurate but slower; not recommended for PE) ###</span>
<div class="viewcode-block" id="point_lens_microlensing_binary_black_hole_analytic">
<a class="viewcode-back" href="../../../gwmat.bilby_custom_FD_source_models.html#gwmat.bilby_custom_FD_source_models.microlensing_source.point_lens_microlensing_binary_black_hole_analytic">[docs]</a>
<span class="k">def</span> <span class="nf">point_lens_microlensing_binary_black_hole_analytic</span><span class="p">(</span>
    <span class="n">frequency_array</span><span class="p">,</span>
    <span class="n">mass_1</span><span class="p">,</span>
    <span class="n">mass_2</span><span class="p">,</span>
    <span class="n">luminosity_distance</span><span class="p">,</span>
    <span class="n">a_1</span><span class="p">,</span>
    <span class="n">tilt_1</span><span class="p">,</span>
    <span class="n">phi_12</span><span class="p">,</span>
    <span class="n">a_2</span><span class="p">,</span>
    <span class="n">tilt_2</span><span class="p">,</span>
    <span class="n">phi_jl</span><span class="p">,</span>
    <span class="n">theta_jn</span><span class="p">,</span>
    <span class="n">phase</span><span class="p">,</span>
    <span class="n">Log_Mlz</span><span class="p">,</span>
    <span class="n">yl</span><span class="p">,</span>
    <span class="o">**</span><span class="n">kwargs</span>
<span class="p">):</span>
<span class="w">    </span><span class="sd">&quot;&quot;&quot;</span>
<span class="sd">    This is similar to above source model </span>
<span class="sd">    &quot;point_lens_microlensing_binary_black_hole&quot; but uses </span>
<span class="sd">    analytic function to compute the wave optics part and </span>
<span class="sd">    doesn&#39;t require a lookup table. </span>
<span class="sd">    This is more accurate but slower, </span>
<span class="sd">    hence not recommended for doing an extensive PE.</span>

<span class="sd">    &quot;&quot;&quot;</span>
    <span class="n">waveform_kwargs</span> <span class="o">=</span> <span class="nb">dict</span><span class="p">(</span>
        <span class="n">waveform_approximant</span><span class="o">=</span><span class="s2">&quot;IMRPhenomPv2&quot;</span><span class="p">,</span>
        <span class="n">reference_frequency</span><span class="o">=</span><span class="mf">50.0</span><span class="p">,</span>
        <span class="n">minimum_frequency</span><span class="o">=</span><span class="mf">20.0</span><span class="p">,</span>
        <span class="n">maximum_frequency</span><span class="o">=</span><span class="n">frequency_array</span><span class="p">[</span><span class="o">-</span><span class="mi">1</span><span class="p">],</span>
        <span class="n">catch_waveform_errors</span><span class="o">=</span><span class="kc">False</span><span class="p">,</span>
        <span class="n">pn_spin_order</span><span class="o">=-</span><span class="mi">1</span><span class="p">,</span>
        <span class="n">pn_tidal_order</span><span class="o">=-</span><span class="mi">1</span><span class="p">,</span>
        <span class="n">pn_phase_order</span><span class="o">=-</span><span class="mi">1</span><span class="p">,</span>
        <span class="n">pn_amplitude_order</span><span class="o">=</span><span class="mi">0</span><span class="p">,</span>
    <span class="p">)</span>
    <span class="n">waveform_kwargs</span><span class="o">.</span><span class="n">update</span><span class="p">(</span><span class="n">kwargs</span><span class="p">)</span>

    <span class="n">lal_res</span> <span class="o">=</span> <span class="n">lal_binary_black_hole</span><span class="p">(</span>
        <span class="n">frequency_array</span><span class="p">,</span>
        <span class="n">mass_1</span><span class="p">,</span>
        <span class="n">mass_2</span><span class="p">,</span>
        <span class="n">luminosity_distance</span><span class="p">,</span>
        <span class="n">a_1</span><span class="p">,</span>
        <span class="n">tilt_1</span><span class="p">,</span>
        <span class="n">phi_12</span><span class="p">,</span>
        <span class="n">a_2</span><span class="p">,</span>
        <span class="n">tilt_2</span><span class="p">,</span>
        <span class="n">phi_jl</span><span class="p">,</span>
        <span class="n">theta_jn</span><span class="p">,</span>
        <span class="n">phase</span><span class="p">,</span>
        <span class="o">**</span><span class="n">kwargs</span>
    <span class="p">)</span>

    
    <span class="k">if</span> <span class="n">Log_Mlz</span> <span class="o">&lt;</span> <span class="o">-</span><span class="mi">3</span><span class="p">:</span>
        <span class="k">return</span> <span class="nb">dict</span><span class="p">(</span><span class="n">plus</span><span class="o">=</span><span class="n">lal_res</span><span class="p">[</span><span class="s2">&quot;plus&quot;</span><span class="p">],</span> <span class="n">cross</span><span class="o">=</span><span class="n">lal_res</span><span class="p">[</span><span class="s2">&quot;cross&quot;</span><span class="p">])</span>
    <span class="n">Mlz</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">power</span><span class="p">(</span><span class="mf">10.</span><span class="p">,</span> <span class="n">Log_Mlz</span><span class="p">)</span>
    <span class="n">Ff</span> <span class="o">=</span> <span class="n">np</span><span class="o">.</span><span class="n">array</span><span class="p">(</span>
        <span class="p">[</span>
            <span class="n">gwmat</span><span class="o">.</span><span class="n">cythonized_point_lens</span><span class="o">.</span><span class="n">Ff_effective</span><span class="p">(</span><span class="n">f</span><span class="p">,</span> <span class="n">ml</span><span class="o">=</span><span class="n">Mlz</span><span class="p">,</span> <span class="n">y</span><span class="o">=</span><span class="n">yl</span><span class="p">)</span>
            <span class="k">for</span> <span class="n">f</span> <span class="ow">in</span> <span class="n">frequency_array</span>
        <span class="p">]</span>
    <span class="p">)</span>
    <span class="n">lhp</span> <span class="o">=</span> <span class="n">Ff</span> <span class="o">*</span> <span class="n">lal_res</span><span class="p">[</span><span class="s2">&quot;plus&quot;</span><span class="p">]</span>
    <span class="n">lhc</span> <span class="o">=</span> <span class="n">Ff</span> <span class="o">*</span> <span class="n">lal_res</span><span class="p">[</span><span class="s2">&quot;cross&quot;</span><span class="p">]</span>
    <span class="k">return</span> <span class="nb">dict</span><span class="p">(</span><span class="n">plus</span><span class="o">=</span><span class="n">lhp</span><span class="p">,</span> <span class="n">cross</span><span class="o">=</span><span class="n">lhc</span><span class="p">)</span></div>



</pre></div>

           </div>
          </div>
          <footer>

  <hr/>

  <div role="contentinfo">
    <p>&#169; Copyright 2023, Anuj Mishra.</p>
  </div>

  Built with <a href="https://www.sphinx-doc.org/">Sphinx</a> using a
    <a href="https://github.com/readthedocs/sphinx_rtd_theme">theme</a>
    provided by <a href="https://readthedocs.org">Read the Docs</a>.
   

</footer>
        </div>
      </div>
    </section>
  </div>
  <script>
      jQuery(function () {
          SphinxRtdTheme.Navigation.enable(true);
      });
  </script> 

</body>
</html>